#!/usr/bin/perl
# change to valid path to perl

# Affiliate Master  Copyright 1999 by Allen Says

&read_form;

########################################
###### START OF CONFIGURATION AREA #####
########################################

# keep track of commissions?  set to "YES", else "NO"
$track_commissions = "YES";

# create a reseller record?  set to "YES", else "NO"
$create_reseller = "YES";

# name of file that stores next reseller id number
$reselleridfile = "resellerid.txt";

# user database file
$resellerdb = "resellerdb.txt";

# order number file
$ordernumfile = "ordernbr.txt";

# determine commissions -- uncomment as needed
# $payout = 10.00;      # example of flat dollar amount
$payout = $FORM{'orderamt'} * .10;   # example of a percentage of orderamt

# list of fields are required for this form
@required_fields = ("firstname","lastname","email");

# list of emails to send when successful form has been filled out
@array_emails = ("emails/touser.txt","emails/tosupport.txt","emails/tosponsor.txt");

# default sponsor name and email if id number passed is not found
# be sure to place a backslash (\) before the @ sign in the email
$default_sponsorname = "My Name";
$default_sponsoremail = "my\@email.com";

# path to sendmail program
$sendmail = '/usr/sbin/sendmail -t';

#####################################
##### END OF CONFIGURATION AREA #####
#####################################













$FORM{'fullname'} = "$FORM{'firstname'} $FORM{'lastname'}";
if ($FORM{'commission'} eq "")
{
   $FORM{'commission'} = $payout;
}

$FORM{'commission'} = sprintf("%.2f", $FORM{'commission'});
$FORM{'orderamt'} = sprintf("%.2f", $FORM{'orderamt'});

# get current date
&get_date;

# verify required fields
&verify_required_fields;

# verify valid credit card number, if nothing passed, no validation
&CC_Verify;

# get members information
&find_member_info;

##### START RESELLER AREA ######
if ($create_reseller eq "YES")
{
   # if no idea, assign id (first initial + last initital + number from reseller file)
   if ($FORM{'idnumber'} eq "") {
      &create_reseller_id; }

   # ensure id number is not already in use
   &check_dupe_reseller;

   # add reseller id to reseller database
   &add_reseller_to_db;
}
##### END RESELLER AREA #####

###### START SALES TRACKING #####
# if set to "YES", track commissions, else skip
if ($track_commissions eq "YES")
{
   # get order number
   &getordernum;

   # writes a basic commissions database file
   &write_order;
}
##### END SALES TRACKING #####

# send the configured emails
&send_emails;

# return user to configured URL
print "Location: $FORM{'return_url'}\n\n";
exit;


sub read_form
{
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);

   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<([^>]|\n)*>//g;
   $value =~ s/<//g;
   $value =~ s/>//g;
   $FORM{$name} = $value;
}
}



######################################################
### sub  verify_required_fields
###
###   Will verify that all required fields have been entered
######################################################
sub verify_required_fields
{
   $number_required = @required_fields;
   $found_in_list = 0;
   $missing_something = 0;

   for ($counter = 0; $counter < $number_required; $counter++)
   {
      $check = $required_fields[$counter];
      $check =~ s/^\s+//g;
      $check =~ s/\s+$//g;

      if ($FORM{$check} eq '')
      {
         if ($missing_something == 0) { &print_missing_header; $missing_something = 1; }
         print "<font color=blue><li> <b>$check</b></font><br>\n";
      }
   }

   if ($missing_something == 1)
   {
      print "<BR><b>Please hit your browser's \"back\" button and enter required information.</b></center><br>\n";
      exit;
   }

}

sub print_missing_header
{
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ooops, You Forgot To Enter Some Data!</title></head>\n";
   print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
   print "<b>Ooops, You Forgot To Enter Some Data</b></font><br><br>\n";
   print "<b>The following fields are required:</b><p>\n";
}



sub create_reseller_id
{
   open(NUMBER,"$reselleridfile");
   flock (NUMBER, 2);
   $reselleridtemp = <NUMBER>;
   close(NUMBER);

   $reselleridtemp++;

   $FORM{'idnumber'} = uc(substr($FORM{'firstname'}, 0, 1)) . uc(substr($FORM{'lastname'}, 0, 1)) . $reselleridtemp;

   open(NUM,">$reselleridfile");
   print NUM "$reselleridtemp";
   close(NUM);
}

sub check_dupe_reseller
{
   my ($match, $line, @lines, %VERIFY);

   open(FILE2, "$resellerdb") or return;
   flock (FILE2, 2);
   @lines = <FILE2>;
   close (FILE2);

   $match = 0;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;

      %VERIFY = &breakup_line($line);

      if($VERIFY{'idnumber'} eq $FORM{'idnumber'})
      {
         $match = 1;
#         &set_member_info;
         last;
      }
   }

   if ($match == 1)
   {
      print "Content-type: text/html\n\n";
      print "<HTML><HEAD><TITLE>ID Number Already In Use</TITLE></HEAD>\n";
      print "<BODY>\n";
      print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
      print "<b>Ooops, The ID Number You Have Chosen Is Already In Use.</b></font><br><br>\n";
      print "<h3>ID Number Choosen:  <b><font color=blue>$FORM{'idnumber'}</font></b><br>\n";
      print "<BR><b>Please hit your browser's \"back\" button and change the ID Number.</b></center><br>\n";
      print "</BODY></HTML>\n";
      exit;
   }
}

sub add_reseller_to_db
{
   if (!(-e $resellerdb)) {
      open(FILE,"> $resellerdb"); }
   else {
      open(FILE,">> $resellerdb"); }

   print FILE "$FORM{'idnumber'}&&$FORM{'sponsorid'}&&$FORM{'fullname'}&&$FORM{'email'}\n";
   close FILE;
}


######################################################
### sub  send_emails
###
######################################################
sub send_emails
{
   my ($number_of_emails,$counter);

   $number_of_emails = @array_emails;

   for ($counter = 0; $counter < $number_of_emails; $counter++)
   {
      &send_this_email ($array_emails[$counter]);
   }
}


sub find_member_info
{
   my ($match, $line, @lines);

   open(FILE2, "$resellerdb") or return;
   flock (FILE2, 2);
   @lines = <FILE2>;
   close (FILE2);

   $match = 0;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;

      %VERIFY = &breakup_line($line);

      if($VERIFY{'idnumber'} eq $FORM{'sponsorid'})
      {
         $match = 1;
         &set_member_info;
         last;
      }
   }

   if ($match == 0)
   {
      $FORM{'sponsorfullname'} = $default_sponsorname;
      $FORM{'sponsoremail'} = $default_sponsoremail;
   }
}

sub set_member_info
{
   $FORM{'sponsorfullname'} = "$VERIFY{'fullname'}";
   $FORM{'sponsoremail'} = $VERIFY{'email'};
}

sub breakup_line
{
   my ($input) = @_;
   my (%DATA);

   ($DATA{'idnumber'},$DATA{'sponsorid'},$DATA{'fullname'},$DATA{'email'}) = split(/&&/, $input);
   return %DATA;
}



######################################################
### sub  send_this_email
###
###   Sends the actual email to the user
######################################################
sub send_this_email
{
   my ($new_file_name) = @_;
   my ($filename,$line,@lines);

   $filename = $new_file_name;
   open(FILE2,"$filename")
      or &cgierr("error in send_this_email. unable to email file: $filename. Reason: $!");
   flock (FILE2,2);
   @lines = <FILE2>;
   close(FILE2);

   open (MAIL2, "| $sendmail")
      or &cgierr("error in send_this_email. unable to sendmail: $sendmail. Reason: $!");

   foreach $line (@lines)
   {
      print MAIL2 &reformat_line($line);
   }

   print MAIL2 "\n";
   close (MAIL2);
}


sub getordernum
{
   open(NUMBER,"$ordernumfile");
   $ordernum = <NUMBER>;
   close(NUMBER);

   ## increase by 1
   $ordernum++;

   open(NUM,">$ordernumfile");
   print NUM "$ordernum";
   close(NUM);

   $FORM{'ordernumber'} = $ordernum;
}


sub cgierr {
# --------------------------------------------------------
# Displays any errors and prints out FORM and ENVIRONMENT
# information. Useful for debugging.

	if (!$html_headers_printed) {
		print "Content-type: text/plain\n\n";
		$html_headers_printed = 1;
	}
	print "<PRE>\nCGI Error: $!\n";
	print "Message: $_[0]\n\n";
	print "_________Form Variables __________\n";
	foreach $key (sort keys %in) {
		print "$key: \t$in{$key}\n";
	}

	print "\n_________Environment Variables__________\n";
	foreach $env (sort keys %ENV) {
		print "$env: \t$ENV{$env}\n";
	}
	print "\n</PRE>";
	exit;
}

######################################################
### sub  reformat_line
###
###   Reformats line with users inputted data.
######################################################
sub reformat_line
{
   my ($line) = @_;

   if ($line =~ /\[/)
   {
      foreach $key (keys(%FORM))
      {
         $line =~ s/\[$key\]/$FORM{$key}/gi;
      }
   }

   return ($line);
}


sub write_order
{
   $commission_file = substr($thedate, 0, 4) . substr($thedate, 4, 2) . ".txt";

   if (!(-e $commission_file)) {
      open(FILE,"> $commission_file"); }
   else {
      open(FILE,">> $commission_file"); }

   print FILE "$FORM{'sponsorid'}&&$FORM{'thedate'}&&$FORM{'ordernumber'}&&$FORM{'orderamt'}&&$FORM{'commission'}\n";
   close FILE;

}

######################################################
### sub  get_date
###
###   Gets the current date
######################################################
sub get_date
{
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $mon = $mon + 1;
   if ($mon < 10)
   {
      $mon = "0$mon";
   }

   if ($mday < 10)
   {
      $mday = "0$mday";
   }

   $year = $year + 1900;

   $thedate = "$year$mon$mday";
   $FORM{'thedate'} = "$year$mon$mday";
}

sub CC_Verify {

$cardnumber = $FORM{'cardnumber'};

# Remove any spaces or dashes in card number
$cardnumber =~ s/ //g;
$cardnumber =~ s/-//g;
$length = length($cardnumber);

# Make sure that only numbers exist
if (!($cardnumber =~ /^[0-9]*$/)) {
 &invalid_cc;
 }

# Verify correct length for each card type
if ($FORM{'cardtype'} eq "VISA") { &vlen; }
if ($FORM{'cardtype'} eq "Master Card") { &mclen; }
if ($FORM{'cardtype'} eq "American Express") { &alen; }
if ($FORM{'cardtype'} eq "Discover") { &nlen; }

sub vlen {
    &invalid_cc unless (($length ==13) || ($length == 16));
}
sub mclen {
    &invalid_cc unless ($length == 16);
}
sub alen {
    &invalid_cc unless ($length == 15);
}
sub nlen {
    &invalid_cc unless ($length == 16);
}

#print "Content-type: text/html\n\nHERE!!!!  $ordernum";exit;


# Now Verify via Mod 10 for each one
if ($FORM{'cardtype'} eq "VISA") { &vver; }
if ($FORM{'cardtype'} eq "Master Card") { &ver16; }
if ($FORM{'cardtype'} eq "American Express") { &ver15; }
if ($FORM{'cardtype'} eq "Discover") { &ver16; }

# pick one for Visa
sub vver {
	if ($length == 13) { &ver13; }
	if ($length == 16) { &ver16; }
}

# For 13 digit cards
sub ver13 {
        $cc0 = substr($cardnumber,0,1);
        $cc1 = substr($cardnumber,1,1);
        $cc2 = substr($cardnumber,2,1);
        $cc3 = substr($cardnumber,3,1);
        $cc4 = substr($cardnumber,4,1);
        $cc5 = substr($cardnumber,5,1);
        $cc6 = substr($cardnumber,6,1);
        $cc7 = substr($cardnumber,7,1);
        $cc8 = substr($cardnumber,8,1);
        $cc9 = substr($cardnumber,9,1);
        $cc10 = substr($cardnumber,10,1);
        $cc11 = substr($cardnumber,11,1);
        $cc12 = substr($cardnumber,12,1);

        $cc1a = $cc1 * 2;
        $cc3a = $cc3 * 2;
        $cc5a = $cc5 * 2;
        $cc7a = $cc7 * 2;
        $cc9a = $cc9 * 2;
        $cc11a = $cc11 * 2;

        if ($cc1a >= 10) {
            $cc1b = substr($cc1a,0,1);
            $cc1c = substr($cc1a,1,1);
            $cc1 = $cc1b+$cc1c;
        } else {
            $cc1 = $cc1a;
        }
        if ($cc3a >= 10) {
            $cc3b = substr($cc3a,0,1);
            $cc3c = substr($cc3a,1,1);
            $cc3 = $cc3b+$cc3c;
        } else {
            $cc3 = $cc3a;
        }
        if ($cc5a >= 10) {
            $cc5b = substr($cc5a,0,1);
            $cc5c = substr($cc5a,1,1);
            $cc5 = $cc5b+$cc5c;
        } else {
            $cc5 = $cc5a;
        }
        if ($cc7a >= 10) {
            $cc7b = substr($cc7a,0,1);
            $cc7c = substr($cc7a,1,1);
            $cc7 = $cc7b+$cc7c;
        } else {
            $cc7 = $cc7a;
        }
        if ($cc9a >= 10) {
            $cc9b = substr($cc9a,0,1);
            $cc9c = substr($cc9a,1,1);
            $cc9 = $cc9b+$cc9c;
        } else {
            $cc9 = $cc9a;
        }
        if ($cc11a >= 10) {
            $cc11b = substr($cc11a,0,1);
            $cc11c = substr($cc11a,1,1);
            $cc11 = $cc11b+$cc11c;
        } else {
            $cc11 = $cc11a;
        }

        $val = $cc0+$cc1+$cc2+$cc3+$cc4+$cc5+$cc6+$cc7+$cc8+$cc9+$cc10+$cc11+$cc12;
        if (substr($val,1,1) !=0 ) {
            &invalid_cc;
        }
	}

# For 16 digit cards
sub ver16 {
        $cc0 = substr($cardnumber,0,1);
        $cc1 = substr($cardnumber,1,1);
        $cc2 = substr($cardnumber,2,1);
        $cc3 = substr($cardnumber,3,1);
        $cc4 = substr($cardnumber,4,1);
        $cc5 = substr($cardnumber,5,1);
        $cc6 = substr($cardnumber,6,1);
        $cc7 = substr($cardnumber,7,1);
        $cc8 = substr($cardnumber,8,1);
        $cc9 = substr($cardnumber,9,1);
        $cc10 = substr($cardnumber,10,1);
        $cc11 = substr($cardnumber,11,1);
        $cc12 = substr($cardnumber,12,1);
        $cc13 = substr($cardnumber,13,1);
        $cc14 = substr($cardnumber,14,1);
        $cc15 = substr($cardnumber,15,1);

        $cc0a = $cc0 * 2;
        $cc2a = $cc2 * 2;
        $cc4a = $cc4 * 2;
        $cc6a = $cc6 * 2;
        $cc8a = $cc8 * 2;
        $cc10a = $cc10 * 2;
        $cc12a = $cc12 * 2;
        $cc14a = $cc14 * 2;

        if ($cc0a >= 10) {
            $cc0b = substr($cc0a,0,1);
            $cc0c = substr($cc0a,1,1);
            $cc0 = $cc0b+$cc0c;
        } else {
            $cc0 = $cc0a;
        }
        if ($cc2a >= 10) {
            $cc2b = substr($cc2a,0,1);
            $cc2c = substr($cc2a,1,1);
            $cc2 = $cc2b+$cc2c;
        } else {
            $cc2 = $cc2a;
        }
        if ($cc4a >= 10) {
            $cc4b = substr($cc4a,0,1);
            $cc4c = substr($cc4a,1,1);
            $cc4 = $cc4b+$cc4c;
        } else {
            $cc4 = $cc4a;
        }
        if ($cc6a >= 10) {
            $cc6b = substr($cc6a,0,1);
            $cc6c = substr($cc6a,1,1);
            $cc6 = $cc6b+$cc6c;
        } else {
            $cc6 = $cc6a;
        }
        if ($cc8a >= 10) {
            $cc8b = substr($cc8a,0,1);
            $cc8c = substr($cc8a,1,1);
            $cc8 = $cc8b+$cc8c;
        } else {
            $cc8 = $cc8a;
        }
        if ($cc10a >= 10) {
            $cc10b = substr($cc10a,0,1);
            $cc10c = substr($cc10a,1,1);
            $cc10 = $cc10b+$cc10c;
        } else {
            $cc10 = $cc10a;
        }
        if ($cc12a >= 10) {
            $cc12b = substr($cc12a,0,1);
            $cc12c = substr($cc12a,1,1);
            $cc12 = $cc12b+$cc12c;
        } else {
            $cc12 = $cc12a;
        }
        if ($cc14a >= 10) {
            $cc14b = substr($cc14a,0,1);
            $cc14c = substr($cc14a,1,1);
            $cc14 = $cc14b+$cc14c;
        } else {
            $cc14 = $cc14a;
        }

        $val = $cc0+$cc1+$cc2+$cc3+$cc4+$cc5+$cc6+$cc7+$cc8+$cc9+$cc10+$cc11+$cc12+$cc13+$cc14+$cc15;
        if (substr($val,1,1) !=0 ) {
            &invalid_cc;
        }
    }


# For 15 digit (Amex) cards
sub ver15 {
        $cc0 = substr($cardnumber,0,1);
        $cc1 = substr($cardnumber,1,1);
        $cc2 = substr($cardnumber,2,1);
        $cc3 = substr($cardnumber,3,1);
        $cc4 = substr($cardnumber,4,1);
        $cc5 = substr($cardnumber,5,1);
        $cc6 = substr($cardnumber,6,1);
        $cc7 = substr($cardnumber,7,1);
        $cc8 = substr($cardnumber,8,1);
        $cc9 = substr($cardnumber,9,1);
        $cc10 = substr($cardnumber,10,1);
        $cc11 = substr($cardnumber,11,1);
        $cc12 = substr($cardnumber,12,1);
        $cc13 = substr($cardnumber,13,1);
        $cc14 = substr($cardnumber,14,1);

        $cc1a = $cc1 * 2;
        $cc3a = $cc3 * 2;
        $cc5a = $cc5 * 2;
        $cc7a = $cc7 * 2;
        $cc9a = $cc9 * 2;
        $cc11a = $cc11 * 2;
        $cc13a = $cc13 * 2;

        if ($cc1a >= 10) {
            $cc1b = substr($cc1a,0,1);
            $cc1c = substr($cc1a,1,1);
            $cc1 = $cc1b+$cc1c;
        } else {
            $cc1 = $cc1a;
        }
        if ($cc3a >= 10) {
            $cc3b = substr($cc3a,0,1);
            $cc3c = substr($cc3a,1,1);
            $cc3 = $cc3b+$cc3c;
        } else {
            $cc3 = $cc3a;
        }
        if ($cc5a >= 10) {
            $cc5b = substr($cc5a,0,1);
            $cc5c = substr($cc5a,1,1);
            $cc5 = $cc5b+$cc5c;
        } else {
            $cc5 = $cc5a;
        }
        if ($cc7a >= 10) {
            $cc7b = substr($cc7a,0,1);
            $cc7c = substr($cc7a,1,1);
            $cc7 = $cc7b+$cc7c;
        } else {
            $cc7 = $cc7a;
        }
        if ($cc9a >= 10) {
            $cc9b = substr($cc9a,0,1);
            $cc9c = substr($cc9a,1,1);
            $cc9 = $cc9b+$cc9c;
        } else {
            $cc9 = $cc9a;
        }
        if ($cc11a >= 10) {
            $cc11b = substr($cc11a,0,1);
            $cc11c = substr($cc11a,1,1);
            $cc11 = $cc11b+$cc11c;
        } else {
            $cc11 = $cc11a;
        }
        if ($cc13a >= 10) {
            $cc13b = substr($cc13a,0,1);
            $cc13c = substr($cc13a,1,1);
            $cc13 = $cc13b+$cc13c;
        } else {
            $cc13 = $cc13a;
        }

        $val = $cc0+$cc1+$cc2+$cc3+$cc4+$cc5+$cc6+$cc7+$cc8+$cc9+$cc10+$cc11+$cc12+$cc13+$cc14;
        if (substr($val,1,1) !=0 ) {
            &invalid_cc;
        }
    }


}

sub invalid_cc {
    print "Content-type: text/html\n\n";
    print "The Credit Card number you've supplied does not pass verification.  Please \n";
    print "use your <B>Back</B> button and verify that the number you've entered is correct \n";
    print "and contains no additional characters other than spaces or hyphens.\n";
    exit;
}

sub kill_input {
    print "Content-type: text/html\n\n";
    $value = "";
    print "<CENTER><H1><FONT COLOR=\"\#FF0000\">CGI Alert</FONT></H1></CENTER>\n";
    print "<CENTER><H3>It appears as though you've tried to \n";
    print "execute a system command via a SSI tag or shell metacharacter. \n";
    print "Please use your <B>Back</B> button, remove the tags or characters and re-submit. \n";
    print "Thanks\!</H3></CENTER>\n";
    exit;
}

sub no_data {
    print "Content-type: text/html\n\n";
    print "It would seem that you've forgotten to fill in one or more of \n";
    print "the required fields.  Please use your <B>Back</B> button to \n";
    print "do that now.  Thanks\!\n";
    exit;
}
